//https://www.tutorialspoint.com/sending-and-receiving-data-with-sockets-in-android
//https://stackoverflow.com/questions/9511630/smsmanager-and-pending-intent

package sk.codeblog.smsgateway;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.graphics.Color;
import android.os.Bundle;

import androidx.appcompat.app.AppCompatActivity;
import android.widget.TextView;

public class MainActivity extends AppCompatActivity {

    private TextView tv_status = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        try {

            Intent service = new Intent(this.getApplicationContext(), SMSGatewayService.class);
            startService(service);

            setContentView(R.layout.activity_main);

            tv_status = (TextView) findViewById(R.id.tv_status);

        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    @Override
    protected void onResume() {
        super.onResume();

        IntentFilter intentFilter = new IntentFilter();
        intentFilter.addAction(Constants.CALLBACK);
        registerReceiver(callbackReceiver, intentFilter);
    }

    @Override
    protected void onPause() {
        super.onPause();

        unregisterReceiver(callbackReceiver);
    }

    private BroadcastReceiver callbackReceiver =
            new BroadcastReceiver() {
                @Override
                public void onReceive(Context context, Intent intent) {

                    int callbackType = intent.getIntExtra(Constants.CALLBACK_TYPE, 0);
                    String message = intent.getStringExtra(Constants.CALLBACK_MSG);
                    int textColor = Color.BLACK;

                    switch (callbackType) {
                        case Constants.CALLBACK_TYPE_ERROR: {
                            textColor = Color.RED;
                        }
                        break;
                        case Constants.CALLBACK_TYPE_RESULT: {
                            int resultCode = getResultCode();
                            if (resultCode == Activity.RESULT_OK) {
                                message += "... OK";
                            } else {
                                textColor = Color.RED;
                                message += "... Failed";
                            }
                        }
                        break;
                    }

                    tv_status.setTextColor(textColor);
                    tv_status.setText(message);
                }
            };
}