package sk.codeblog.smsgateway;

import android.content.Context;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketException;

class ServiceThread extends Thread {

    private Context context;
    private ServerSocket serverSocket = null;

    public ServiceThread(Context context)
    {
        this.context = context;
    }

    @Override
    public void run() {

        try {
            serverSocket = new ServerSocket(1234);
            Functions.sendInfoToApp(this.context , Constants.CALLBACK_TYPE_INFO,"Listening...");

            while (!this.isInterrupted()) {
                Socket socket = serverSocket.accept();
                processSocket(socket);
            }
        }
        catch (SocketException socExcp)
        {
            String errMsg = socExcp.getMessage();
            if (errMsg.equals("Socket closed")) {

                Functions.sendInfoToApp(this.context , Constants.CALLBACK_TYPE_ERROR, "Service error: " + errMsg);

                socExcp.printStackTrace();
            }

        }
        catch (IOException e) {

            this.cancel();

            e.printStackTrace();
        }
    }

    public void cancel()
    {
        if (this.serverSocket != null)
        {
            try {
                this.interrupt();

                this.serverSocket.close();
                this.serverSocket = null;

                Functions.sendInfoToApp(this.context , Constants.CALLBACK_TYPE_INFO, "Service interrupted");
            }
            catch (Exception ex) { ex.printStackTrace();}
        }
    }

    private void processSocket(Socket socket)
    {
        CommandThread th = new CommandThread(  this.context,  socket);
        th.start();
    }
}